"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceProvider = void 0;
var utils_1 = require("../utils");
var ScopedContext_1 = require("./ScopedContext");
var ServiceProvider = /** @class */ (function () {
    function ServiceProvider(lifetimes) {
        Object.defineProperty(this, "lifetimes", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "proxy", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.lifetimes = lifetimes;
        this.proxy = (0, utils_1.proxyOf)(this);
    }
    Object.defineProperty(ServiceProvider.prototype, "provide", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (selector) {
            return new ScopedContext_1.ScopedContext(this).provide(selector);
        }
    });
    return ServiceProvider;
}());
exports.ServiceProvider = ServiceProvider;
