"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractSelector = exports.proxyOf = exports.propertyOf = exports.Services = void 0;
var ServiceCollection_1 = require("./ServiceCollection");
var Services = function () { return new ServiceCollection_1.ServiceCollection(); };
exports.Services = Services;
var _propertyOf = new Proxy({}, { get: function (_, p) { return p; } });
var propertyOf = function () { return _propertyOf; };
exports.propertyOf = propertyOf;
var proxyOf = function (self) {
    return new Proxy(self, { get: function (t, p) { return t.provide(p); } });
};
exports.proxyOf = proxyOf;
function extractSelector(options) {
    switch (typeof options) {
        case 'function':
            return options((0, exports.propertyOf)());
        case 'symbol':
        case 'string':
            return options;
        default:
            throw new Error("extractSelector could not match anything");
    }
}
exports.extractSelector = extractSelector;
