import { LifetimeCollection, Selector } from '../ServiceCollection';
import { IServiceProvider } from './IServiceProvider';
export declare class ServiceProvider<E = any> implements IServiceProvider<E> {
    readonly lifetimes: LifetimeCollection<E>;
    readonly proxy: E;
    constructor(lifetimes: LifetimeCollection<E>);
    provide<T>(selector: Selector<T, E>): T;
}
